typedef struct _dyn_buffer
{	// A Dynamic buffer structure
	unsigned char **pbuf;
	unsigned long y_size,init_x_size,x;
} dyn_buffer;


void **Malloc2D(unsigned long d1_size,unsigned long d2_size,unsigned long elem_bytes);

void AddConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void SetConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void Copy2D(long **d_ar2D,const long **s_ar2D,unsigned long d1_size,unsigned long d2_size);

void Print2D(long **ar2D,unsigned long d1_size,unsigned long d2_size);

//void Print2D(double **ar2D,unsigned long d1_size,unsigned long d2_size);

void MinConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void MaxConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void Free2DArray(void ** ar,unsigned long size_d1);

void Free3DArray(void *** ar,unsigned long size_d1,unsigned long size_d2);

void InitializeDynBuffer(dyn_buffer *pdbuf,unsigned long init_x_size);

void *DynAlloc(dyn_buffer *pdbuf,unsigned long bsize);

void FreeDynBuffer(dyn_buffer *pdbuf);